 @program prog_code,prog_name

prog_code:
 move.w   6+rect1(PC),-(a7)
 move.w   4+rect1(PC),-(a7)
 move.w   2+rect1(PC),-(a7)
 move.w   rect1(PC),-(a7)
 jsr      flib[erase_rect]
 jsr      flib[frame_rect]
 lea      8(a7),a7
 move.w   #1,-(a7)
 jsr      romlib[set_font]
 lea      2(a7),a7
 move.w   #4,-(a7)
 pea      str1(PC)
 move.w   2+point1(PC),-(a7)
 move.w   point1(PC),-(a7)
 jsr      romlib[puttext]
 lea      10(a7),a7
 move.w   #2,-(a7)
 jsr      romlib[set_font]
 lea      2(a7),a7
 move.w   point2(PC),d1
 move.w   2+point2(PC),d2
 move.l   #1,d3
 move.l   $5350,d0
 divu     #18,d0
 swap     d0
 clr.w    d0
 swap     d0
 move.l   d0,d5
changeloop:
 move.l   d5,d0
 bsr      printdecimal
 move.l   #1,d3
 move.w   point2(PC),d1
 move.w   2+point2(PC),d2
 jsr      flib[idle_loop]
 cmp      #264,d0
 beq      end
 cmp      #13,d0
 beq      enter
 cmp      #338,d0
 beq      up
 cmp      #344,d0
 beq      down
 cmp      #4434,d0
 beq      medup
 cmp      #4440,d0
 beq      meddown
 cmp      #8530,d0
 beq      bigup
 cmp      #8536,d0
 beq      bigdown
 cmp      #100,d0
 beq      default

 bra      changeloop
enter:
 mulu     #18,d5
 move.l   d5,$5350
end:
 rts

up:
 add.w    #1,d5
 bra      hicheck

down:
 sub.w    #1,d5
 bra      lowcheck

medup:
 add.w    #10,d5
 bra      hicheck

meddown:
 sub.w    #10,d5
 bra      lowcheck

bigup:
 add.w    #100,d5
 bra      hicheck

bigdown:
 sub.w    #100,d5
 bra      lowcheck

default:
 move.l   #334,d5
 bra      changeloop

hicheck:
 cmp      #9999,d5
 bls      changeloop
 move.l   #9999,d5
 bra      changeloop

lowcheck:
 cmp      #9999,d5
 bls      changeloop
 move.l   #0,d5
 bra      changeloop

printdecimal:
 divu     #10,d0
 swap     d0
 add.w    #$30,d0
 clr.l    d4
 move.w   d0,d4
 clr.w    d0
 swap     d0
 divu     #10,d0
 swap     d0
 add.w    #$30,d0
 rol      #8,d0
 add.w    d0,d4
 clr.w    d0
 swap     d0
 rol.w    #1,d3
 lea      num1(PC),a0
 add.l    d3,a0
 move.w   d4,(a0)
 ror.w    #1,d3
 dbra     d3,printdecimal
 move.w   #4,-(a7)
 pea      num1(PC)
 move.w   d2,-(a7)
 move.w   d1,-(a7)
 jsr      romlib[puttext]
 lea      10(a7),a7
 rts

rect1     dc.w 50,39,190,89
point1    dc.w 53,45
point2    dc.w 53,65
str1      dc.b "Auto power down time:",0
num1      ds.b 6

prog_name:
 dc.b "APD changer, by Noah Stein",0,0

 reloc_open
 add_library flib
 add_library romlib
 reloc_close
 end
